routes/web.php
        Route::get('/download', 'ResourceController@download');
    });

    Route::group(['prefix' => '/collections/{slug}'], function () {
        // show single resource
        Route::get('/', 'CollectionController@show');
    });
});
/***
    Route::prefix('/')->namespace('Auth')->group(function () {
        // show web login form
        Route::get('login', 'LoginController@showLoginForm')->name('login');

        // show web registration form
        Route::get('register', 'LoginController@showRegistrationForm');
        Route::get('register-ok', 'LoginController@showRegistrationSuccess');

        //Password Reset Routes...
        Route::get('password-reset', 'ForgotPasswordController@showLinkRequestForm');
        Route::post('password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('password.email');
        Route::get('password/reset', 'ResetPasswordController@showResetForm')->name('password.reset');
        Route::post('password/resetV2', 'ResetPasswordController@updatePassword')->name('password.update');
    });
*** */
Route::post('password/resetV2', 'Auth\ResetPasswordController@updatePassword')->name('password.update');
    Route::prefix('/')->namespace('Api\V1')->group(function () {

        // login from web by using api
        Route::post('login', 'AuthenticateController@authenticate');

        // logout from web by using api
        Route::post('logout', 'AuthenticateController@logout');
    });

    Route::group(['prefix' => 'users', 'namespace' => 'Api\V1'], function () {

        Route::get('/', 'UserController@index');
        Route::post('/', 'UserController@store');

        // User Methods
        Route::group(['prefix' => '{id}'], function () {

            Route::get('/', 'UserController@show');
            Route::put('/', 'UserController@update');
            Route::delete('/', 'UserController@delete');

            // Get User Profile
            Route::get('profile', 'UserController@getProfile');

            // Update user password
            //Route::post('password/reset', 'Auth\PasswordController@postReset');

            Route::put('profile', 'UserController@updateProfile');
            Route::post('profile/image', 'UserController@updateImage');
            Route::post('password/update', 'UserController@updatePassword');
            Route::delete('profile/image', 'UserController@deleteImage');
            Route::post('/avatar', 'UserController@setAvatar');
            Route::get('/settings', 'UserController@getSettings');
            Route::post('/settings', 'UserController@setSettings');
        });
    });

    Route::group(['prefix' => 'polls', 'namespace' => 'Api\V1'], function () {
        Route::post('/{id}/vote', 'PollController@vote');
        Route::get('/{id}/result', 'PollController@result');
        Route::get('/last', 'PollController@last');

        Route::resource('/', 'PollController');
    });




Route::get('/webapi/resources', 'Api\V1\ResourceController@index');
Route::get('/webapi/resources-by-query', 'Api\V1\ResourceController@getResourcesByQuery');
Route::post('/webapi/resources', 'Api\V1\ResourceController@store');
Route::get('/webapi/resources/latest', 'Api\V1\ResourceController@getLatestResources');
Route::get('/webapi/resources/latest/{id}', 'Api\V1\ResourceController@getLatestResourcesByAuthor');
Route::get('/webapi/resources/ranked/{id}', 'Api\V1\ResourceController@getRankedResourcesByAuthor');
Route::post('/webapi/resources/{id}/like', 'Api\V1\ResourceController@like');
Route::get('/webapi/resources/{id}', 'Api\V1\ResourceController@show');
Route::post('/webapi/resources/{id}', 'Api\V1\ResourceController@updateResource');
Route::post('/webapi/resources/{id}/file', 'Api\V1\ResourceController@updateFileResource');
Route::post('/webapi/resources/{id}/new-update', 'Api\V1\ResourceController@newUpdate');
Route::get('/webapi/resources/{id}/edit', 'Api\V1\ResourceController@edit');
Route::post('/webapi/resources/updateInfo/{id}', 'Api\V1\ResourceController@updateInfo');
Route::post('/webapi/resources/file/delete', 'Api\V1\ResourceController@fileDelete');
Route::get('/webapi/resources/{slug}/download-content', 'Api\V1\ResourceController@downloadContent');
Route::get('/webapi/resources/{slug}/download-attachment', 'Api\V1\ResourceController@downloadAttachment');
Route::post('/webapi/ratings', 'Api\V1\RatingController@setRating');

//Route::get('/webapi/collections/{collection_id}/resources', 'Api\V1\CollectionController@getResources');
Route::get('/webapi/collections/{collection_id}/resources', 'Api\V1\CollectionController@getResourcesByCollection');
Route::post('/webapi/collections/sync/resources', 'Api\V1\CollectionController@syncResources');
Route::get('/webapi/collections/{slug}', 'Api\V1\CollectionController@show');


Route::get('/webapi/tags', 'Api\V1\ResourceController@searchTags');
Route::get('/webapi/author/{id}', 'Api\V1\ResourceController@getAuthor');
Route::get('/webapi/authors', 'Api\V1\ResourceController@searchAuthors');

Route::resource('/tags', 'Api\V1\TagController');

Route::get('/ads', 'Api\V1\ResourceController@getAds');
Route::get('/linker/{uuid}', 'Api\V1\ResourceController@linker');
Route::get('/mailablex', function () {
    return new \App\Mail\UserActivationCode(App\Models\User::find(1));
});
Route::get('/mailable/{email}', function ($email) {
    Mail::raw('Test email', function ($message) use ($email) {
        $message->subject('Testing Mailables')
            ->to($email);
    });
});

Route::get('/launching/{email}', function ($email) {
    Mail::to($email)->send(new \App\Mail\LaunchingV2());
});

/* Route::get('/elasticsearch/{query}', 'ElasticSearchController@search');
Route::resource('/elastic', 'ElasticSearchController'); */


Route::post('/accept', 'Web\HomeController@acceptTerms');
Route::get('/badges', 'Web\HomeController@badges');

//login admin
Route::post('loginAdmin', 'LoginAdminController@loginAdmin');
Route::get('admin_login', 'LoginAdminController@loginAdminView');

Route::get('reset_password', 'ResetPasswordController@index');


Route::group(['prefix' => 'admin', 'namespace' => 'Web'], function() {
    //'middleware' => 'backend',
//oute::group(['prefix' => 'admin', 'namespace' => 'Web','middleware' => 'backend'], function() {
    // Rutas de los controladores dentro del Namespace "App\Http\Controllers\Admin"
    Route::view('/', 'dashboard.index')->name('admin');

    //ads
    Route::resource('/ads', 'AdminAdsController');

    Route::get('/password-reset/token={token}', 'AdminUserController@showEmail');
    //recursos
    Route::get('/recursos/datatables', 'AdminResourceController@getDatatable');
    Route::resource('/recursos', 'AdminResourceController');
    Route::post('/recursos/publishedResources/{id}', 'AdminResourceController@publishedResources');
    Route::post('/recursos/recover/{id}', 'AdminResourceController@recover')->name('recursos.recover');

    //publicamos recurso
    Route::get('/recursos/{id}/status', 'AdminResourceController@togglePublished')->name('recursos.published');

    //usuarios
    Route::get('/usuarios/datatables', 'AdminUserController@getDatatable');
    Route::post('/usuarios/avatar', 'AdminUserController@manageAvatar');
    Route::resource('/usuarios', 'AdminUserController');

    //encuestas
    Route::get('encuestas', 'AdminPollController@index');
    //Route::resource('/encuestas', 'Web\AdminPollController')->middleware('backend');

    Route::resource('/encuestas', 'AdminPollController');
    Route::get('/encuestas/{id}/status', 'AdminPollController@status')->name('encuestas.status');
    Route::get('/encuestas/datatables', 'AdminPollController@getDatatable');

    //collections
    Route::get('/collections/datatables', 'AdminCollectionController@getDatatable');
    Route::get('/collections/resources/{collection_id}', 'AdminCollectionController@resources');
    Route::resource('/collections', 'AdminCollectionController');

    //resource
    //Route::get('/resources/{id}', 'AdminResourceController@edit');
    Route::get('/resources/edit/{resource_id}', 'AdminResourceController@edit');
   // Route::get('resourceEdit','AdminResourceController@edit');
    //notifications
    Route::get('/notifications', 'AdminNotificationController@index')->name('notifications.index');
    Route::get('/notifications/{id}/read', 'AdminNotificationController@markAsRead')->name('notification.read');
    Route::get('/notifications/read', 'AdminNotificationController@markAllAsRead')->name('notification.all.read');
    Route::get('/notifications/unread', 'Web\NotificationController@getUnreadNotifications');

    //gallery
    Route::get('/gallery','GalleryController@index')->name('gallery.index');
    Route::get('/gallery/order','GalleryController@order')->name('gallery.order');
    Route::get('/gallery/datatables','GalleryController@getDatatable');
    Route::get('/gallery/create','GalleryController@create')->name('gallery.create');
    Route::post('/gallery/create','GalleryController@store')->name('gallery.store');
    Route::get('/gallery/edit/{id}','GalleryController@edit')->name('gallery.edit');
    Route::post('/gallery/edit/{id}','GalleryController@update')->name('gallery.update');
    Route::post('/gallery/change/{id}','GalleryController@change')->name('gallery.change');
    Route::post('/gallery/destroy{id}','CategoryController@destroy')->name('gallery.destroy');

    //categories
    Route::get('/categories','CategoryController@list')->name('categories.list');
    Route::get('/categories/datatables', 'CategoryController@getDatatable');
    Route::get('/categories/create','CategoryController@create');
    Route::put('/categories/update/{id}','CategoryController@update');
    Route::post('/categories/store','CategoryController@store');
    Route::get('/categories/{id}','CategoryController@edit');
    Route::post('/categories/edit/{id}','CategoryController@update');
    Route::get('/categories/show/{id}','CategoryController@show');

app/Models/Gallery.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Gallery extends Model
{
    //
}

app/Http/Controllers/Api/V1/GalleryController.php
<?php

namespace App\Http\Controllers\Api\V1;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Service\Sanitizable;
use DB;
use App\Gallery;

class GalleryController extends Controller
{
    use Sanitizable;

    public function __construct()
    {}

    /**
     * Display a listing of the collections.
     *
     * @return JsonResponse
     */
/*     public function GetOrders()
    {
        $data['resource_header'] = true;
        $data['gallery_user'] = DB::table('gallery')
            ->where(['status'=> true, 'type' => 'user'])
            ->select('gallery.id', 'gallery.image', 'gallery.type')
            ->get();

        $data['gallery_visitant'] = DB::table('gallery')
            ->where(['status'=> true, 'type' => 'visitant'])
            ->select('gallery.id', 'gallery.image', 'gallery.type')
            ->get();

        return response()->json([
            'success' => true,
            'code' => 200,
            'message' => 'Lista cargada correctamente',
            'data' => $data
        ]);
    } */

    public function UpdateOrder(Request $request)
    {
        //update by typo
        $request->validate([
            'gallery_user' => 'required|array',
            'gallery_visitant' => 'required|array'
        ]);

        $gallery_user = $request->gallery_user;
        $gallery_visitant = $request->gallery_visitant;

        foreach($gallery_user as $key => $item){
            dd($key,$item);
            $image = Gallery::findOrFail($item);
            $image->update([
                'order' => $key,
            ]);
        }

        foreach($gallery_visitant as $key => $item){
            $image = Gallery::findOrFail($item);
            $image->update([
                'order' => $key,
            ]);
        }
        return response()->json([
            'success' => true,
            'code' => 200,
            'message' => 'Actualizado correctamente',
            'data' => []
        ]);
    }
}

app/Http/Controllers/Web/GalleryController.php
<?php

namespace App\Http\Controllers\Web;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Freshbitsweb\Laratables\Laratables;
use App\Gallery;
use Illuminate\Support\Facades\DB;

class GalleryController extends Controller
{
    public function __construct()
    {
        //only-admin
    }

    public function index()
    {
        $gallery = Gallery::all();
        return view('dashboard.gallery.index')->with(compact('gallery'));
    }

    //create DataTable with Laratable Custom Action
    public function getDatatable()
    {
        return Laratables::recordsOf(Gallery::class, null);
    }

    public function show($id){

        $gallery = Gallery::with('media')->find($id);
        $gallery['image'] = $gallery->media[0]->getUrl();
        return view('dashboard.gallery.show');
    }

    /**
     * Return all gallery images active
     */
    public function order()
    {

        /***
        $query_user = Gallery::where(['status'=> true, 'type' => 'user'])
        ->get();

        $gallery_user = $query_user->transform(function ($item, $key) {
            $item['image'] = $item->media[0]->getUrl();
            return $item;
        });

        $query_visitant =  Gallery::with('media')
        ->where(['status'=> true, 'type' => 'visitant'])
        ->get();

        $gallery_visitant = $query_visitant->transform(function ($item, $key) {
            $item['image'] = $item->media[0]->getUrl();
            /* dd($item);

            return $item;
        });
        **/

        return view('dashboard.gallery.order');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //order
        return view('dashboard.gallery.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //validate image
        $request->validate([
            'image' => 'dimensions:min_width=1356,min_height=516
            |mimes:jpeg,jpg,png
            |required
            |max:5000',
            'type' => 'required',
            'status' => 'required',
        ]);
        //custom validation response message

        $image = new Gallery();
        $image->image = $request->image;
        $image->status = $request->status;
        $image->type = $request->type;


        $image->addMediaFromRequest('image')
        ->toMediaCollection('gallery');

        $image->save();
        //notify changes

        return redirect()->to('gallery.index')->with('success', 'Imagén creada correctamente');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param $slug
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $image = Gallery::with('media')
            ->find($id);
        $image->image = $image->media[0]->getUrl();
        return view('dashboard.gallery.edit', compact( 'image' ));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'image' => 'dimensions:min_width=1356,min_height=516
            |mimes:jpeg,jpg,png
            |required
            |max:5000',
            'type' => 'required',
            'status' => 'required',
        ]);

        $gallery = Gallery::findOrFail($id);

        $gallery->update([
            'type' => $request->type,
            'status' => $request->status,
        ]);

        //update image from the request
        if ($request->has('image') && $request->file('image')->isValid()) {
            $gallery->getFirstMedia('gallery')->delete();
            $gallery->addMediaFromRequest('image')
                ->toMediaCollection('gallery', 's3');
        }
        return redirect()->route('gallery.index')->with('success', 'Actualización exitosa');
    }

    public function change($id){
        $gallery = Gallery::findOrFail($id);

        $gallery->update([
            'status' => $gallery->status ? false: true,
        ]);
        return redirect()->route('gallery.index')->with('success', 'Actualización exitosa');
    }

    public function destroy($id){

    }
}

resources/views/dashboard/gallery/create.blade.php
@extends('layouts.dashboard')

@section('content')
    <div class="container-fluid">

        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Galería</a></li>
                    <li class="breadcrumb-item active">Crear</li>
                </ol>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Crear imagén</h4>

                        <form id="form-create-poll" class="mt-4" action="{{route('gallery.store')}}" enctype="multipart/form-data" method="POST">
                            {{csrf_field()}}

                            <div class="form-group">
                                <label>Tipo</label>
                                <select name="type" class="form-control">
                                    <option value="visitant">Visitante</option>
                                    <option value="user">Usuario</option>
                                </select>
                                @if($errors->has('type'))
                                    <span>{{$errors->first('type')}}</span>
                                @endif
                            </div>


                            <div class="form-group">
                                <label>Imagen:</label>
                                <input type="file" name="image" class="form-control">
                                <p class="help-block">La imagén debe tener igual o mayor a 1368 x 516. </br>
                                    No puede pesar más de 3 mb el archivo.
                                </p>
                                @if($errors->has('image'))
                                    <span>{{$errors->first('image')}}</span>
                                @endif
                            </div>
                            <!--leyenda con specificaciones-->

                            <div class="form-group">
                                <label>Estatus</label>
                                <select name="status" class="form-control">
                                    <option value="1">Activo</option>
                                    <option value="0">Inactivo</option>
                                </select>
                                @if($errors->has('status'))
                                    <span>{{$errors->first('status')}}</span>
                                @endif
                            </div>
                            <input type="hidden" name="order" value="1" id="">

                            <button type="submit" class="btn btn-primary">Guardar</button>

                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @include('dashboard.partials.footer')
@endsection

@section('script')
    <script>
       /*  const app = new Vue({
            el: '#form-create-poll',
            data() {
                return {
                    responses: [],
                    date_from: null,
                    date_to: null,
                }
            },
            mounted() {
                let today = new Date().toISOString().slice(0, 10);
                this.date_from = today;
                this.date_to = today;
                $(".select2").select2();
            },
            methods: {
                addResponse() {
                    this.responses.push("");
                },
                deleteResponse(key) {
                    this.responses.splice(key, 1);
                },
            },

        }); */
    </script>
@endsection

resources/views/dashboard/gallery/edit.blade.php
@extends('layouts.dashboard')

@section('content')
    <div class="container-fluid">

        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Galería</a></li>
                    <li class="breadcrumb-item active">Edición</li>
                </ol>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Editar imagén</h4>
                        
                        <form id="form-create-poll" class="mt-4" action="{{route('gallery.update', $image->id)}}" enctype="multipart/form-data" method="POST">
                            {{csrf_field()}}
                            {{method_field('PUT')}}
                            
                            <div class="form-group">
                                <label>Tipo</label>
                                <select name="type" class="form-control">
                                    <option value="visitant" {{ $image->type == 'visitant' ? 'selected' : ''}}>Visitante</option>
                                    <option value="user" {{ $image->type == 'user' ? 'selected' : ''}}>Usuario</option>
                                </select>
                                @if($errors->has('type'))
                                    <span>{{$errors->first('type')}}</span>
                                @endif
                            </div>

                            <div class="row">
                                <div class="col-sm-6 offset-sm-3">
                                    <img src="{{$image->image}}" width="100%" class="mx-auto">
                                </div>
                            </div>

                            <div class="form-group">
                                <label>Imagen:</label>
                                <input type="file" name="image" class="form-control">
                                <p class="help-block">La imagén debe tener igual o mayor a 1368 x 516. </br> 
                                    No puede pesar más de 3 mb el archivo.
                                </p>
                                @if($errors->has('image'))
                                    <span>{{$errors->first('image')}}</span>
                                @endif
                            </div>
                            <!--leyenda con specificaciones-->

                            <div class="form-group">
                                <label>Estatus</label>
                                <select name="status" class="form-control">
                                    <option value="1" {{ $image->status ? 'selected' : ''}}>Activo</option>
                                    <option value="0" {{ !$image->status ? 'selected' : ''}}>Inactivo</option>
                                </select>
                                @if($errors->has('status'))
                                    <span>{{$errors->first('status')}}</span>
                                @endif
                            </div>

                            <button type="submit" class="btn btn-primary">Actualizar</button>
                            
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @include('dashboard.partials.footer')
@endsection

resources/views/dashboard/gallery/index.blade.php
@extends('layouts.dashboard')

@section('content')
    <div id="collections-list" class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Galéria</a></li>
                    <li class="breadcrumb-item active">Listado</li>
                </ol>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Listado de imágenes</h4>
                        <table id="example" class="table table-striped table-bordered" style="width: 100%;">
                            <thead>
                                <tr>
                                    <th>Orden</th>
                                    <th>Imagen</th>
                                    <th>Tipo</th>
                                    <th>Activo</th>
                                    <th>Acciones</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($gallery as $gallery)
                                    <tr>
                                        <td>{{$gallery->order}}</td>
                                        <td>
                                            <img src="{{asset('storage/images').'/' .$gallery->image}}" alt="" style="width: 60px;">
                                        </td>
                                        <td>{{$gallery->type}}</td>
                                        <td>
                                              @if ($gallery->status != '1')
                                                       <label <?php 
                                                if($gallery->status == '0'){echo('Inactivo');}
                                                 
                                                ?>>{{$gallery->status}}</label>
                                               @else
                                                Activo
                                              @endif
                                        </td>
                                        <td>
                                            <a class="btn btn-primary btn-sm" href="{{route('usuarios.edit', $gallery->id)}}">
                                                <i class="mdi mdi-table-edit"></i>
                                            </a>
                                            <form action="{{route('usuarios.destroy', $gallery->id)}}" method="POST"
                                                  style="display: inline-block">
                                                {{csrf_field()}}
                                                {{method_field('delete')}}
                                                <button class="btn btn-danger btn-sm"><i class="mdi mdi-delete"></i>
                                                </button>
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                        <div class="clearfix"></div>
                    </div>
                </div>
            </div>
        </div>

    </div>
    @include('dashboard.partials.footer')
@endsection

@section('script')
   <script>
 $("#exampleModal").modal("show"); $("#exampleModal").css("z-index", "1042");
</script>

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.21/css/dataTables.bootstrap4.min.css" defer/>
<script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js" defer ></script>
<script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js" defer></script>
<script type="text/javascript">
  $(document).ready( function () {
    $('#example').DataTable();
} );
</script>
@endsection